/* Sistemas Integrados TECNISA
   Servios

Nome: BUSCA_ALMOX

Descrio:
   Retorna o almoxarifado do produto.
Criao:
28/07/05 - Welbert G. Moitinha */

CREATE OR REPLACE FUNCTION BUSCA_ALMOX( P_CDFILIAL  IN FILIAL.CDFILIAL%TYPE,
                                        P_CDLOJA    IN LOJA.CDLOJA%TYPE,
                                        P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE)RETURN VARCHAR2
AS
   V_CDALMOX      ALMOXARIFADO.CDALMOXARIFE%TYPE;
   V_IDUTILALMOX  PARAMFILIAL.IDUTILALMOX%TYPE;
   V_IDCTRLESTQ   PARAMFILIAL.IDCTRLESTQ%TYPE;
   V_CDALMOXARIFE PARAMFILIAL.CDALMOXARIFE%TYPE;
   V_CDALMOXPROD  PARAMFILIAL.CDALMOXARIFE%TYPE;
   V_CTREG INTEGER;
BEGIN

   SELECT MAX(IDUTILALMOX), MAX(IDCTRLESTQ), MAX(CDALMOXARIFE)
   INTO   V_IDUTILALMOX, V_IDCTRLESTQ, V_CDALMOXARIFE
   FROM
      PARAMFILIAL
   WHERE
      (CDFILIAL = P_CDFILIAL);

   IF(V_IDCTRLESTQ <> 'N')AND(V_IDUTILALMOX = 'S')THEN
      SELECT MAX(CDALMOXPRCLI)
      INTO V_CDALMOXPROD
      FROM PRODFILI PF, PRODUTO P
      WHERE PF.CDFILIAL  = P_CDFILIAL  AND
            P.CDPRODUTO  = P_CDPRODUTO AND
            PF.CDPRODUTO = P.CDPRODESTO;

      IF V_CDALMOXPROD IS NOT NULL THEN
         RETURN(V_CDALMOXPROD);
      ELSE
         SELECT
            MAX(CDALMOXARIFE)  INTO V_CDALMOXPROD
         FROM LOJA
         WHERE
            CDFILIAL = P_CDFILIAL AND
            CDLOJA   = P_CDLOJA;

         IF V_CDALMOXPROD IS NULL THEN
            V_CDALMOXPROD := V_CDALMOXARIFE;
         END IF;

         IF V_CDALMOXPROD IS NULL THEN
            V_CDALMOXPROD := ' ';
         END IF;

         RETURN(V_CDALMOXPROD);
      END IF;
   ELSE
      RETURN(' ');
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('BUSCA_ALMOX','5.05.007'); END;
/

