/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* Compras e Suprimentos                                                      */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 8335_SUPSTP_GRAVA_COTWEB                                             */
/*                                                                            */
/* Descrio:                                                                 */
/*  Gerar cotaes apartir das alteraes feitas pelo Fornecedor na Internet  */
/*                                                                            */
/* Criao:                                                                   */
/*   12/12/2002 - Adriano de Arajo                                           */
/*                                                                            */
/* Manutenes:                                                               */
/*   /  /   -                                                                 */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @C:\WIN_PRJ\SQL\End_Conv\Oracle\8335_SUPSTP_GRAVA_COTWEB.SQL               */
/******************************************************************************/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GRAVA_COTWEB'  and
            type = 'P'           and
            u.uid = o.uid        and
            u.name = USER)
   DROP PROCEDURE GRAVA_COTWEB;
GO

CREATE PROCEDURE GRAVA_COTWEB
  @P_CDFILIAL     VARCHAR(4),
  @P_NRPEDCOLETA  VARCHAR(10),
  @P_CDREGIAO     VARCHAR(3),
  @P_CDFORNECED   VARCHAR(21),
  @P_NRSEMINI     VARCHAR(2),
  @P_NRSEMFIN     VARCHAR(2),
  @P_ENTRALISTA   VARCHAR(1),
  @P_COTA_N_GER   VARCHAR(1) OUTPUT,
  @P_CDOPERINCL   VARCHAR(12)
AS
DECLARE  @V_NRCOLEPRECO   VARCHAR(20);
DECLARE  @V_DTCOLEPREC    DATETIME;
DECLARE  @V_CDFORMPGTO    VARCHAR(2);
DECLARE  @V_IDTPFORPGTO   VARCHAR(1);
DECLARE  @V_NRPARCPGTO    NUMERIC(2);
DECLARE  @V_NRDIAPGTO     NUMERIC(2);
DECLARE  @V_IDUTDIAPGTO   VARCHAR(1);
DECLARE  @V_IDTIPFRETE    VARCHAR(1);
DECLARE  @V_CDTIPCOB      VARCHAR(2);
DECLARE  @V_VRPERDESC     NUMERIC(10,2);
DECLARE  @V_CDPRODFORN    VARCHAR(20);
DECLARE  @V_CDEMPRESA     VARCHAR(2);
DECLARE  @V_INSCESTA      VARCHAR(16);
DECLARE  @V_CTITMCOL      INT;
DECLARE  @V_APAGACOL      VARCHAR(1);
DECLARE  @V_AUX           VARCHAR(12);
DECLARE	@V_CDPRODUTO     VARCHAR(10);
DECLARE  @V_CDARVPROD	  VARCHAR(20);
DECLARE  @V_CDMARCA		  VARCHAR(5);
DECLARE  @V_QTPRODPEDCOL  NUMERIC(10,3);
DECLARE  @V_VRITEMPEDCOL  NUMERIC(15,5);
DECLARE  @V_DTINIPERCOT   DATETIME;
DECLARE  @V_DTFINPERCOT   DATETIME;
DECLARE  @V_NRPEDIDOCOL   VARCHAR(10);
DECLARE  @V_CDOPERADOR    VARCHAR(12);
DECLARE  @V_IDUTISTATCOT  VARCHAR(1);
DECLARE  @V_IDSITUCOLETA  VARCHAR(1);
DECLARE  @V_CDFORNECED    VARCHAR(21);
DECLARE  @V_CDREGIAO      VARCHAR(3);
DECLARE  @V_DTPEDCOLETA   DATETIME;
DECLARE  @V_IDSITUCADA    VARCHAR(1);
DECLARE  @V_CDQUALIF      VARCHAR(2);
DECLARE  @V_IDFORNAUTO    VARCHAR(1);
DECLARE  @V_DTVALQUALIF   DATETIME;
DECLARE  @V_IDMOTNGERPEDCOL VARCHAR(10);
DECLARE  @V_GEROUREGISTRO   VARCHAR(1);
DECLARE  @V_COUNT           INT;
DECLARE  @V_COUNTAUX        INT;
DECLARE  @V_MARCAAUX INT;

BEGIN
  SET @P_COTA_N_GER = 'N';
  SELECT
    @V_IDTIPFRETE = MAX(IDTPFRETFORN),
    @V_CDTIPCOB   = MAX(CDTIPCOB),
    @V_VRPERDESC  = MAX(CASE IDTPDESCFORN WHEN 'C' THEN VRPEDESCFORN  ELSE 0 END)
  FROM
     FORNECEDOR
  WHERE
     CDFORNECED = @P_CDFORNECED;

  SELECT @V_NRPEDIDOCOL = MAX(P.NRPEDIDOCOL),
         @V_CDOPERADOR  = MAX(P.CDOPERADOR)
  FROM PEDCOLETA P
  WHERE P.CDFILIAL    = @P_CDFILIAL
    AND P.NRPEDCOLETA = @P_NRPEDCOLETA
    AND P.CDREGIAO    = @P_CDREGIAO
    AND P.CDFORNECED  = @P_CDFORNECED;

  SELECT @V_NRCOLEPRECO = MAX(I.NRCOLEPRECO)
  FROM ITEMCOLE I, COLETAPR C
  WHERE I.CDFILIAL    = @P_CDFILIAL
    AND I.NRPEDIDOCOL = @V_NRPEDIDOCOL
    AND I.CDFILIAL    = C.CDFILIAL
    AND I.NRCOLEPRECO = C.NRCOLEPRECO
    AND C.CDOPERADOR  = @V_CDOPERADOR;

  IF @V_NRCOLEPRECO IS NULL BEGIN
    SET @V_AUX = 'COLETA' + @P_CDFILIAL;
    EXEC NOVO_CODIGO @V_AUX,
                     @P_SEQUENCIAL = @V_NRCOLEPRECO OUTPUT,
                     @P_QTDE = 1;

    SET @V_NRCOLEPRECO = SUBSTRING(@V_NRCOLEPRECO, 11, 10);

    SET @V_IDSITUCOLETA = 'C';
    SELECT @V_IDUTISTATCOT = ISNULL(MAX(IDUTISTATCOT), 'N')
    FROM PARASUPRI
    WHERE PARASUPRI.CDFILIAL = @P_CDFILIAL;

    IF @V_IDUTISTATCOT = 'S' BEGIN
       SET @V_IDSITUCOLETA = 'A';
    END;

    INSERT INTO COLETAPR
       (CDFILIAL,     NRCOLEPRECO,  DTCOLEPREC,
        DTINIVALCOL,  DTFINVALCOL,  CDOPERADOR,
        IDTIPCOLREG,   NRSEMAINIC, NRSEMAFINAL, IDSITUCOLETA, IDDISMONTLIS, CDOPERINCL, DTINCLCOLET)
    SELECT
       CDFILIAL,      @V_NRCOLEPRECO, ISNULL(@V_DTCOLEPREC, CONVERT( DATETIME, CONVERT (VARCHAR, GETDATE(),103))),
       DTINIPERCOT,   DTFINPERCOT,   CDOPERADOR,
       'W', @P_NRSEMINI, @P_NRSEMFIN, @V_IDSITUCOLETA, @P_ENTRALISTA, @P_CDOPERINCL, CONVERT( DATETIME, CONVERT (VARCHAR, GETDATE(),103))
    FROM
       PEDCOLETA
    WHERE
       CDFILIAL    = @P_CDFILIAL    AND
       CDREGIAO    = @P_CDREGIAO    AND
       CDFORNECED  = @P_CDFORNECED  AND
       NRPEDCOLETA = @P_NRPEDCOLETA;

    SET @V_APAGACOL = 'S';
  END
  ELSE BEGIN
    SET @V_APAGACOL = 'N';
  END;

  SET @V_GEROUREGISTRO = 'N';

  DELETE FROM LOGNGERAPEDCOL
  WHERE CDFILIAL    = @P_CDFILIAL
    AND NRPEDCOLETA = @P_NRPEDCOLETA
    AND CDREGIAO    = @P_CDREGIAO
    AND CDFORNECED  = @P_CDFORNECED;

  DECLARE C_PEDIDO CURSOR FOR
    (SELECT
       ITEMPEDCOL.CDPRODUTO,
       PRODUTO.CDARVPROD,
       ITEMPEDCOL.CDMARCA,
       ITEMPEDCOL.QTPRODPEDCOL,
       ITEMPEDCOL.VRITEMPEDCOL,
       PEDCOLETA.DTINIPERCOT,
       PEDCOLETA.DTFINPERCOT,
       PEDCOLETA.CDFORNECED,
       PEDCOLETA.CDREGIAO,
       PEDCOLETA.DTPEDCOLETA,
       FORNECEDOR.IDSITUCADA,
       FORNECEDOR.CDQUALIF,
       FORNECEDOR.IDFORNAUTO,
       FORNECEDOR.DTVALQUALIF
     FROM
       ITEMPEDCOL,
       PRODUTO,
       FORNECEDOR,
       PEDCOLETA LEFT JOIN LEILAO
                        ON PEDCOLETA.CDLEILAO = LEILAO.CDLEILAO
     WHERE
       PEDCOLETA.CDFORNECED = ITEMPEDCOL.CDFORNECED AND
       PEDCOLETA.CDFILIAL = ITEMPEDCOL.CDFILIAL AND
       PEDCOLETA.NRPEDCOLETA = ITEMPEDCOL.NRPEDCOLETA AND
       PEDCOLETA.CDREGIAO = ITEMPEDCOL.CDREGIAO AND

       (((PEDCOLETA.CDLEILAO IS NOT NULL) /*AND (LEILAO.IDSITULEILAO = 'C')*/ AND (ITEMPEDCOL.IDSELELEILAO = 'S'))
        OR (PEDCOLETA.CDLEILAO IS NULL))  AND

       ITEMPEDCOL.CDPRODUTO   = PRODUTO.CDPRODUTO AND
       PEDCOLETA.CDFILIAL     = @P_CDFILIAL    AND
       PEDCOLETA.NRPEDCOLETA  = @P_NRPEDCOLETA AND
       PEDCOLETA.CDFORNECED   = @P_CDFORNECED  AND
       PEDCOLETA.CDREGIAO     = @P_CDREGIAO    AND
       FORNECEDOR.CDFORNECED  = PEDCOLETA.CDFORNECED AND
       ITEMPEDCOL.CDFILIAL    = @P_CDFILIAL    AND
       ITEMPEDCOL.NRPEDCOLETA = @P_NRPEDCOLETA AND
       ITEMPEDCOL.CDFORNECED  = @P_CDFORNECED  AND
       ITEMPEDCOL.CDREGIAO    = @P_CDREGIAO    AND
       ISNULL(ITEMPEDCOL.VRITEMPEDCOL,0) > 0 )

    OPEN C_PEDIDO;
    FETCH NEXT FROM C_PEDIDO INTO @V_CDPRODUTO, @V_CDARVPROD, @V_CDMARCA, @V_QTPRODPEDCOL,
                                  @V_VRITEMPEDCOL, @V_DTINIPERCOT, @V_DTFINPERCOT,
                                  @V_CDFORNECED,@V_CDREGIAO,@V_DTPEDCOLETA,@V_IDSITUCADA,
                                  @V_CDQUALIF,@V_IDFORNAUTO,@V_DTVALQUALIF;
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
       SET @V_COUNT = NULL;
       SELECT
          @V_COUNT = COUNT(*)
       FROM ITEMCOLE
       WHERE ITEMCOLE.CDFILIAL    = @P_CDFILIAL
         AND ITEMCOLE.NRCOLEPRECO = @V_NRCOLEPRECO
         AND ITEMCOLE.CDMARCA     = @V_CDMARCA
         AND ITEMCOLE.CDREGIAO    = @V_CDREGIAO
         AND ITEMCOLE.CDFORNECED  = @V_CDFORNECED
         AND ITEMCOLE.CDPRODUTO   = @V_CDPRODUTO;

       IF @V_COUNT = 0 BEGIN
          SET @V_IDMOTNGERPEDCOL = '';
          SET @V_MARCAAUX     = NULL;
       /* IdMotivNDupl [1] = '1' Fornecedor inativo */
          IF @V_IDSITUCADA = 'I' BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END;

       /* IdMotivNDupl [2] = '1' Fornecedor no atende  regio */
          SET @V_COUNT = 0;
          SELECT
             @V_COUNT = COUNT(*)
          FROM
             REFOREG
          WHERE
             @V_CDREGIAO   = REFOREG.CDREGIAO   AND
             @V_CDFORNECED = REFOREG.CDFORNECED;

          IF @V_COUNT <> 0 BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END;

       /* IdMotivNDupl [3] = '1' Qualificao de produto por fornecedor */
          SET @V_COUNT = 0;
          SELECT
             @V_COUNT = COUNT(*)
          FROM
             QFOPRODFORN,
             PARASUPRI
          WHERE
             (PARASUPRI.CDFILIAL     = @P_CDFILIAL)            AND
             (QFOPRODFORN.CDPRODUTO  = @V_CDPRODUTO)  AND
             (QFOPRODFORN.CDFORNECED = @V_CDFORNECED) AND
             ((QFOPRODFORN.IDFORNAPROV = 'N'    AND QFOPRODFORN.IDFORNAUTOR = 'N') OR
              ((QFOPRODFORN.IDFORNAPROV = 'S')  AND
                 ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                   @V_DTPEDCOLETA > (DATEADD(MM,1,QFOPRODFORN.DTVALPRFORN)- DAY(DATEADD(MM,1,QFOPRODFORN.DTVALPRFORN)))) OR
                  (PARASUPRI.IDULTIDTVALQ = 'D' AND
                   @V_DTPEDCOLETA > QFOPRODFORN.DTVALPRFORN)) ) );

          IF @V_COUNT <> 0 BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END;

       /* IdMotivNDupl [4] = '1' Qualificao de marca por produto */
          SET @V_COUNT = 0;
          SELECT
             @V_COUNT = COUNT(*)
          FROM
             QFOMARPROD,
             PARASUPRI
          WHERE
            (PARASUPRI.CDFILIAL   = @P_CDFILIAL)           AND
            (QFOMARPROD.CDPRODUTO = @V_CDPRODUTO) AND
            (QFOMARPROD.CDMARCA   = @V_CDMARCA)   AND
            ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'N') OR
             ((QFOMARPROD.IDAPRMARPRO = 'S') AND
                ((PARASUPRI.IDULTIDTVALQ = 'M' AND
                  @V_DTPEDCOLETA > (DATEADD(MM,1,QFOMARPROD.DTVALAPROVA)- DAY(DATEADD(MM,1,QFOMARPROD.DTVALAPROVA)))) OR
                 (PARASUPRI.IDULTIDTVALQ = 'D' AND
                  @V_DTPEDCOLETA > QFOMARPROD.DTVALAPROVA))) );

          SET @V_COUNTAUX = 0;
          SELECT
             @V_COUNTAUX = COUNT(*)
          FROM
             QFOMARPROD
          WHERE
             QFOMARPROD.CDPRODUTO = @V_CDPRODUTO AND
             QFOMARPROD.CDMARCA   = @V_CDMARCA;

          IF @V_COUNTAUX = 0 BEGIN
             SET @V_MARCAAUX = NULL;
             SELECT
                @V_MARCAAUX = PARASUPRI.CDMARCA
             FROM
                PARASUPRI
             WHERE
                (PARASUPRI.CDFILIAL     = @P_CDFILIAL) AND
                (PARASUPRI.IDMARSEMQUA = 'N' OR PARASUPRI.IDMARSEMQUA IS NULL);
             IF @V_MARCAAUX IS NOT NULL BEGIN
                SET @V_COUNTAUX = 1;
             END;

          END;

          IF (@V_COUNT = 0) AND (@V_COUNTAUX <> 0) BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END;

       /* IdMotivNDupl [5] = '1' Qualificao de fornecedor */
          SET @V_COUNT = 0;
          SELECT
             @V_COUNT = COUNT(*)
          FROM
             QUALIFICACAO,
             PARASUPRI
          WHERE
             (@V_CDQUALIF       = QUALIFICACAO.CDQUALIF) AND
             (PARASUPRI.CDFILIAL         = @P_CDFILIAL)           AND
             (@V_IDFORNAUTO     = 'N')                   AND
             ((QUALIFICACAO.IDPERCOTCMP  = '2')                   OR
              ((PARASUPRI.IDULTIDTVALQ   = 'D'                    AND
                @V_DTFINPERCOT > @V_DTVALQUALIF)           OR
              (PARASUPRI.IDULTIDTVALQ = 'M'                       AND
               @V_DTFINPERCOT > (DATEADD(MM,1,@V_DTVALQUALIF)- DAY(DATEADD(MM,1,@V_DTVALQUALIF))))));

          IF @V_COUNT <> 0 BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END;

       /* IdMotivNDupl [6] = '1' Produto no cadastrado para o fornecedor */
          SET @V_COUNT = 0;
          SELECT
             @V_COUNT = COUNT(*)
          FROM
             PRODFORNCOMP
          WHERE
             (PRODFORNCOMP.CDPRODCOMPL = @V_CDPRODUTO) AND
             (PRODFORNCOMP.CDFORNECED  = @V_CDFORNECED);

          IF @V_COUNT = 0  BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL + '0';
          END;

       /* IdMotivNDupl [7] = '1' Marca Inativa */
          SET @V_COUNT = 0;
          SELECT
             V_COUNT = COUNT(*)
          FROM
             MARCA
          WHERE MARCA.CDMARCA      = @V_CDMARCA
            AND MARCA.IDMARCAATIVA = 'I';

          IF @V_COUNT <> 0 BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL+'1';
          END
          ELSE BEGIN
             SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL+'0';
          END;

          SET @V_IDMOTNGERPEDCOL = @V_IDMOTNGERPEDCOL+'000';

          IF @V_IDMOTNGERPEDCOL = '0000000000' BEGIN
             SET @V_APAGACOL = 'N';
             SET @V_CDPRODFORN  = NULL;
             SET @V_CDFORMPGTO  = NULL;
             SET @V_IDTPFORPGTO = NULL;
             SET @V_NRPARCPGTO  = NULL;
             SET @V_NRDIAPGTO   = NULL;
             SET @V_IDUTDIAPGTO = NULL;
             SELECT
               @V_CDPRODFORN  = MAX(CDARVPROD),
               @V_CDFORMPGTO  = MAX(CDFORMPGTO),
               @V_IDTPFORPGTO = MAX(IDTPFORPGPRF),
               @V_NRPARCPGTO  = MAX(NRPARCPGTPRF),
               @V_NRDIAPGTO   = MAX(NRDIAPGFIPRF),
               @V_IDUTDIAPGTO = MAX(IDUTDIAPGPRF)
             FROM
               PRODFORN,
               PRODUTO
             WHERE
               CDFORNECED = @P_CDFORNECED AND
               PRODFORN.CDPRODUTO = PRODUTO.CDPRODUTO AND
               CDARVPROD  = (SELECT
                                MAX(P.CDARVPROD)
                             FROM
                                PRODFORN,
                                PRODUTO P
                             WHERE
                                P.CDPRODUTO = PRODFORN.CDPRODUTO AND
                                CDFORNECED = @P_CDFORNECED   AND
                                @V_CDARVPROD LIKE P.CDARVPROD + '%');

             IF @V_IDTPFORPGTO IS NULL BEGIN
                SET @V_CDFORMPGTO  = NULL;
                SET @V_IDTPFORPGTO = NULL;
                SET @V_NRPARCPGTO  = NULL;
                SET @V_NRDIAPGTO   = NULL;
                SET @V_IDUTDIAPGTO = NULL;
                SELECT
                   @V_CDFORMPGTO  = MAX(CDFORMPGTO),
                   @V_IDTPFORPGTO = MAX(IDTPFORPGTFO),
                   @V_NRPARCPGTO  = MAX(NRPARCPGTOFO),
                   @V_NRDIAPGTO   = MAX(NRDIAPGFIXFO),
                   @V_IDUTDIAPGTO = MAX(IDUTDIAPGTFO)
                FROM
                   FORNECEDOR
                WHERE
                   CDFORNECED = @P_CDFORNECED;

                INSERT INTO ITEMCOLE
                     (CDFILIAL,     NRCOLEPRECO,  CDFORNECED,    CDREGIAO,
                      CDPRODUTO,    CDMARCA,      QTACMPITMCOL,  VRPRECUNIITM,
                      DTINIVALITM,  DTFINVALITM,   IDTIPFREITM,
                      CDTIPCOB,     VRPERDESITM,   CDFORMPGTO,
                      IDTPFOPGTCOL, NRPARCPGTCOL, NRDIAPGFXCOL,  IDUTDIAPGCOL, NRPEDIDOCOL, CDOPERINCL, DTINCLITMCOL)
                   VALUES(@P_CDFILIAL, @V_NRCOLEPRECO,  @P_CDFORNECED,     @P_CDREGIAO,
                          @V_CDPRODUTO,    @V_CDMARCA, @V_QTPRODPEDCOL,
                          @V_VRITEMPEDCOL, @V_DTINIPERCOT, @V_DTFINPERCOT,
                          @V_IDTIPFRETE, @V_CDTIPCOB, @V_VRPERDESC, @V_CDFORMPGTO, @V_IDTPFORPGTO,
                          @V_NRPARCPGTO, @V_NRDIAPGTO, @V_IDUTDIAPGTO, @V_NRPEDIDOCOL, @P_CDOPERINCL, CONVERT( DATETIME, CONVERT(VARCHAR, GETDATE(),103)))

                DELETE PZOPGTITMCOL
                WHERE  NRCOLEPRECO  = @V_NRCOLEPRECO AND
                       CDFORNECED   = @P_CDFORNECED  AND
                       CDFILIAL     = @P_CDFILIAL    AND
                       CDREGIAO     = @P_CDREGIAO    AND
                       CDPRODUTO    = @V_CDPRODUTO  AND
                       CDMARCA      = @V_CDMARCA;

                INSERT INTO PZOPGTITMCOL
                  (CDFILIAL, NRCOLEPRECO, CDFORNECED, CDPRODUTO,
                   CDMARCA, CDREGIAO, NRDIASPGTCOL, VRPERCPGTCOL)
                SELECT
                   @P_CDFILIAL,
                   @V_NRCOLEPRECO,
                   @P_CDFORNECED,
                   @V_CDPRODUTO,
                   @V_CDMARCA,
                   @P_CDREGIAO,
                   PRAZOPGTFORN.NRDIASPGTOFO,
                   PRAZOPGTFORN.VRPERCPGTOFO
                FROM
                   PRAZOPGTFORN
                WHERE
                   PRAZOPGTFORN.CDFORNECED = @P_CDFORNECED;
             END
             ELSE BEGIN
                INSERT INTO ITEMCOLE
                     (CDFILIAL,     NRCOLEPRECO,  CDFORNECED,    CDREGIAO,
                      CDPRODUTO,    CDMARCA,      QTACMPITMCOL,  VRPRECUNIITM,
                      DTINIVALITM,  DTFINVALITM,   IDTIPFREITM,
                      CDTIPCOB,     VRPERDESITM,   CDFORMPGTO,
                      IDTPFOPGTCOL, NRPARCPGTCOL, NRDIAPGFXCOL,  IDUTDIAPGCOL, NRPEDIDOCOL, CDOPERINCL, DTINCLITMCOL)
                   VALUES(@P_CDFILIAL, @V_NRCOLEPRECO,  @P_CDFORNECED,     @P_CDREGIAO,
                          @V_CDPRODUTO,    @V_CDMARCA, @V_QTPRODPEDCOL,
                          @V_VRITEMPEDCOL, @V_DTINIPERCOT, @V_DTFINPERCOT,
                          @V_IDTIPFRETE, @V_CDTIPCOB, @V_VRPERDESC, @V_CDFORMPGTO, @V_IDTPFORPGTO,
                          @V_NRPARCPGTO, @V_NRDIAPGTO, @V_IDUTDIAPGTO, @V_NRPEDIDOCOL, @P_CDOPERINCL, CONVERT( DATETIME, CONVERT(VARCHAR, GETDATE(),103)))

                DELETE PZOPGTITMCOL
                WHERE  NRCOLEPRECO  = @V_NRCOLEPRECO AND
                       CDFORNECED   = @P_CDFORNECED  AND
                       CDFILIAL     = @P_CDFILIAL    AND
                       CDREGIAO     = @P_CDREGIAO    AND
                       CDPRODUTO    = @V_CDPRODUTO  AND
                       CDMARCA      = @V_CDMARCA;

                INSERT INTO PZOPGTITMCOL
                  (CDFILIAL, NRCOLEPRECO, CDFORNECED, CDPRODUTO,
                   CDMARCA, CDREGIAO, NRDIASPGTCOL, VRPERCPGTCOL)
                SELECT
                  @P_CDFILIAL,
                  @V_NRCOLEPRECO,
                  @P_CDFORNECED,
                  @V_CDPRODUTO,
                  @V_CDMARCA,
                  @P_CDREGIAO,
                  PZOPGTPRFO.NRDIASPGPRFO,
                  PZOPGTPRFO.VRPERCPGPRFO
                FROM
                  PZOPGTPRFO,
                  PRODUTO
                WHERE
                  PZOPGTPRFO.CDPRODUTO = PRODUTO.CDPRODUTO AND
                  CDFORNECED = @P_CDFORNECED AND
                  CDARVPROD  = @V_CDPRODFORN;
             END;

             SET @V_CDEMPRESA = NULL;
             SELECT
                @V_CDEMPRESA = MAX(CDEMPRESA)
             FROM
                EMITENTEAF,
                PRODUTO
             WHERE
                PRODUTO.CDPRODUTO = EMITENTEAF.CDPRODUTO AND
                CDFILIAL = @P_CDFILIAL AND
                @V_CDARVPROD LIKE PRODUTO.CDARVPROD + '%';

             IF @V_CDEMPRESA IS NULL BEGIN
                SET @V_CDEMPRESA = NULL;
                SELECT
                   @V_CDEMPRESA = MAX(CDEMPRESA)
                FROM
                   PARCMPSUP
                WHERE
                   CDFILIAL = @P_CDFILIAL;
             END ;

             SET @V_INSCESTA = NULL;
             SELECT
               @V_INSCESTA = MIN(INSCRESTAD.CDINSCESTA)
             FROM
               EMPRESA,
               INSCRMUNICIP,
               INSCRESTAD
             WHERE
               EMPRESA.CDEMPRESA = @V_CDEMPRESA            AND
               EMPRESA.CDEMPRESA = INSCRMUNICIP.CDEMPRESA AND
               EMPRESA.CDEMPRESA = INSCRESTAD.CDEMPRESA;

             SET @V_DTCOLEPREC = ISNULL(@V_DTCOLEPREC, CONVERT( DATETIME, CONVERT (VARCHAR, GETDATE(),103)));
             EXEC IMPOSTO_ITEMCOL @V_CDEMPRESA, @V_INSCESTA,
                                  @P_CDFORNECED, @P_CDFILIAL,
                                  @V_NRCOLEPRECO, @P_CDFORNECED,
                                  @P_CDREGIAO, @V_CDPRODUTO,
                                  @V_CDMARCA, @V_DTCOLEPREC;
          END
          ELSE BEGIN
             SET @P_COTA_N_GER = 'S';
             INSERT INTO LOGNGERAPEDCOL
                (CDFILIAL,
                 NRPEDCOLETA,
                 CDFORNECED,
                 CDREGIAO,
                 CDPRODUTO,
                 CDMARCA,
                 IDMOTNGERPEDCOL)
             VALUES
                (@P_CDFILIAL,
                 @P_NRPEDCOLETA,
                 @V_CDFORNECED,
                 @V_CDREGIAO,
                 @V_CDPRODUTO,
                 @V_CDMARCA,
                 @V_IDMOTNGERPEDCOL);
          END;
       END;
       FETCH NEXT FROM C_PEDIDO INTO @V_CDPRODUTO, @V_CDARVPROD, @V_CDMARCA, @V_QTPRODPEDCOL,
                                     @V_VRITEMPEDCOL, @V_DTINIPERCOT, @V_DTFINPERCOT,
                                     @V_CDFORNECED,@V_CDREGIAO,@V_DTPEDCOLETA,@V_IDSITUCADA,
                                     @V_CDQUALIF,@V_IDFORNAUTO,@V_DTVALQUALIF;
    END;
    CLOSE C_PEDIDO;
    DEALLOCATE C_PEDIDO;

    /* Forar execuo da trigger - soluo temporria */
    IF (@V_GEROUREGISTRO = 'S') AND (@V_APAGACOL = 'N') BEGIN
       UPDATE
         ITEMCOLE
       SET
         IDTPFOPGTCOL = IDTPFOPGTCOL
       WHERE
         CDFILIAL    = @P_CDFILIAL AND
         NRCOLEPRECO = @V_NRCOLEPRECO;
    END;

    IF @V_APAGACOL = 'S' BEGIN
      DELETE
        COLETAPR
      WHERE
        CDFILIAL    = @P_CDFILIAL AND
        NRCOLEPRECO = @V_NRCOLEPRECO;
    END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_COTWEB','5.05.005';
GO

